(
-- save ui first
local cui_file = cui.getConfigFile()
cui.saveConfigAs (if cui_file == undefined then (getdir #maxData + "UI\Workspaces\usersave\Workspace__usersave__.cuix") else cui_file)

filein "macro.mcr"

local ico_16a = (pathconfig.appendpath (getdir #usericons) "RugGenerator_16a.bmp")
local ico_24a = (pathconfig.appendpath (getdir #usericons) "RugGenerator_24a.bmp")
if doesFileExist ico_16a do deletefile ico_16a
if doesFileExist ico_24a do deletefile ico_24a

cui_file = cui.getconfigfile()

dotnet.loadassembly "system.xml"

local cui_xml = dotnetobject "system.xml.xmldocument"

cui_xml.load cui_file

local root_node = (cui_xml.selectnodes "//ADSK_CUI/CUIWindows").itemof[0]

local to_main_toolbar = true
local toolbar_node = undefined
local items_node = undefined
if to_main_toolbar then (
    toolbar_node = (cui_xml.selectnodes "//ADSK_CUI/CUIWindows/Window[@objectName='Main Toolbar']").itemof[0]
    items_node = toolbar_node.ChildNodes.itemof[0]
)
else (
    toolbar_node = cui_xml.createelement "Window"
    toolbar_node.setattribute "objectName" "Main Toolbar"
    toolbar_node.setattribute "name" "Main Toolbar"
    toolbar_node.setattribute "type" "T"
    toolbar_node.setattribute "cType" "1"
    toolbar_node.setattribute "toolbarRows" "1"
    root_node.appendChild toolbar_node
    items_node = cui_xml.createelement "Items"
    toolbar_node.appendChild items_node
)
local item_node = cui_xml.createelement "Item"
item_node.setattribute "typeID" "2"
item_node.setattribute "type" "CTB_MACROBUTTON"
item_node.setattribute "width" "0"
item_node.setattribute "height" "0"
item_node.setattribute "controlID" "0"
item_node.setattribute "macroTypeID" "3"
item_node.setattribute "macroType" "MB_TYPE_ACTION"
item_node.setattribute "actionTableID" "647394"
item_node.setattribute "imageID" "-1" 
item_node.setattribute "imageName" ""
item_node.setattribute "actionID" "RugGenerator`RugGenerator"
items_node.appendChild item_node

cui_xml.save cui_file
cui.loadConfig cui_file
if to_main_toolbar do cui.showToolbar "RugGenerator"
colorMan.reinitIcons()
messagebox "Rug Generator have been installed.\n\nYou should see the R logo in your main toolbar.\n\nEnjoy!" beep:true title:"Installation done"
)

